#!/usr/bin/ruby

#define formatting around the characters
colon = ':'
semicolon = '; '
comma = ','
open_brace = ' {'
close_brace = '}'

file = !STDIN.tty? ? STDIN.read : File.read(ARGV[0])
file.split('}').each do |block| 
 #one block per line 
 block.gsub!(/\n/,' ')

 #get rid of comments
 block.gsub!(/\/\*.*?\*\//m,'')

 #apply formatting defined above
 block.gsub!(/\s*:\s*/,colon) 
 block.gsub!(/\s*;\s*/,semicolon) 
 block.gsub!(/\s*,\s*/,comma) 
 block.gsub!(/\s*\{\s*/,open_brace) 

 #single spacing
 block.gsub!(/\s\s+/,' ')

 puts block.strip + close_brace if block.include?('{') 
end
